/*	Adapted from Dave McPherson's code:
 *	http://support.microsoft.com/kb/q190351/
 */

#if !defined INCLUDE_COMPILER_H
#define INCLUDE_COMPILER_H

#define MAX_CONSOLE_CHARS 8192

#include <windows.h>

using namespace std;



class Compiler
{
public:
		   Compiler		  ();
		   Compiler		  (const char *cmd);
	BOOL   Compile		  ();
	BOOL   Compile		  (const char *cmd);
	void   SetCommandLine (const char *cmd);
	char   CStrOutput[2048];

protected:
	void	ReadAndHandleOutput	  (HANDLE hPipeRead);	
	void	LaunchRedirectedChild (HANDLE hChildStdOut, HANDLE hChildStdIn,
										HANDLE hChildStdErr);
protected:
	const char  *commandLine;
	HANDLE		hChildProcess;
	HANDLE		hStdIn;
	BOOL		bRunThread;	
};

#endif