#include "stdafx.h"
#include "Compiler.h"

#include <string.h>

#define MAX_LINES 64

char	*g_outputStr[MAX_LINES];
int		g_outputCounter;
char	g_customMsg[256];

const char *g_errorMessage = {"Error:%s on line %s"};
const char *g_warningMessage = {"Warning:%s on line %s"};

void Output(char *output, const char *srcfile)
{
	char	stLine[8];
	char	*sep1;
	char	*sep2;
	int		len;	

	*g_customMsg = '\0';

	if(strstr(output, srcfile) == output) {
		sep1 = strchr(output, '(');
		sep2 = strchr(output, ')');
		
		if(sep1 == NULL || sep2 == NULL)
			return;

		len = sep2 - sep1 - 1;
		strncpy(stLine, sep1 + 1, (size_t)len);
		stLine[len] = '\0';
		
		
		if(sep1 == NULL)
			return;

		if(sep2 = strstr(output + strlen(srcfile), "error")) {
			 sep1 = strchr(sep2, ':');
			 if(sep1 == NULL)
				 return;
			_snprintf(g_customMsg, 256, g_errorMessage, sep1 + 1, stLine);
		}
		else if(sep2 = strstr(output + strlen(srcfile), "warning")) {
			 sep1 = strchr(sep2, ':');
			 if(sep1 == NULL)
				 return;
			_snprintf(g_customMsg, 256, g_warningMessage, sep1 + 1, stLine);
		}
		else
			return;

		printf("%s\n", g_customMsg);

	}


	else
		printf("%s\n", output);

}

int main(int argc, char **argv)
{
	int i;
	int len;
	char args[512];
	char output[256];
	char *sep;
	char outfile[_MAX_PATH];
	char curdir[_MAX_PATH];
	
	g_outputCounter = 0;

	if(argc < 3)
		return 1;
	
	strcpy(outfile, argv[2]);
	
	sep = strstr(outfile, ".amxx");

	if(sep == NULL)
		return 1;
	
	*sep = '\0';	
	strcpy(curdir, argv[0]);
	sep = strrchr(curdir, '\\');
	*sep = '\0';	
	len = sprintf(args, "spcomp.exe %s", argv[1]);
	
	_snprintf(args, 512, "spcomp \"%s\" \"%s.smx\"", argv[1], outfile);

	memset(output, 0, 256);

	SetCurrentDirectory(curdir);

	Compiler compiler;
	compiler.SetCommandLine(args);
	compiler.Compile();

	char *ot;
	
	ot = compiler.CStrOutput;
	len = strlen(ot);
	sep = ot;
	for(i = 0; i < len; i++) {
		if(ot[i] == '\r' && g_outputCounter < MAX_LINES) {
			ot[i] = '\0';
			g_outputStr[g_outputCounter++] = sep;
			sep = ot + i + 2;
		}
	}

	for (i = 0; i < g_outputCounter; i++)
		Output(g_outputStr[i], argv[1]);

	return 0;

}